1:给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
import java.util.HashMap;
import java.util.Map;
class Solution {
public int[] twoSum(int[] nums, int target) {
int[] indexs = new int[2];
// 建立k-v ,一一对应的哈希表
HashMap<Integer,Integer> hash = new HashMap<Integer,Integer>();
for(int i = 0; i < nums.length; i++){
if(hash.containsKey(nums[i])){
indexs[0] = i;
indexs[1] = hash.get(nums[i]);
return indexs;
}
// 将数据存入 key为补数 ,value为下标
hash.put(target-nums[i],i);
}
// // 双重循环 循环极限为(n^2-n)/2
// for(int i = 0; i < nums.length; i++){
// for(int j = nums.length - 1; j > i; j --){
// if(nums[i]+nums[j] == target){
// indexs[0] = i;
// indexs[1] = j;
// return indexs;
// }
// }
// }
return indexs;
package com.Leetcode.数组;
import java.util.HashMap;
/**
-
@author
-
@date 2020/11/13
-
给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
-
-
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
-
给定 nums = [2, 7, 11, 15], target = 9
-
-
因为 nums[0] + nums[1] = 2 + 7 = 9
-
所以返回 [0, 1]
*/
public class Num1 {
public static void main(String[] args) {
int[] nums = new int[]{2, 7, 11, 15};
int target = 9;
int[] result = twoSum(nums,target);
System.out.println(result[0]+" "+result[1]);
}public static int[] twoSum(int[] nums, int target) {
int[] anws = new int[2];
/* for (int i = 0; i < nums.length-1; i++) {
int result = target-nums[i];
for(int j=i+1;j<nums.length;j++){
if (nums[j] == result){
anws[0]=i;
anws[1]=j;
return anws;
}
}}*/ HashMap<Integer,Integer> map = new HashMap<>(); for (int i = 0; i < nums.length; i++) { if (map.containsKey(nums[i])){ anws[0]=map.get(nums[i]); anws[1]=i; return anws; } map.put(target-nums[i],i); } return anws;
}
}